
--[[
Copyright (C) 2008 Pascal Julien

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

--]]

-- ##  Version pour PSP de ICC cod par Dungeon
-- Ce programme a pour but de crer les donnes (enregistres dans des fichiers textes) ncessaires  l'utilisation du moteur de collision isomtriques cr par moi mme (Dungeon  :-)  )

-- ## Debut du travail : 10/01/08
-- ## Dernire modification par : Dungeon, le 24/05/08


-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

-- Ici se trouve les fonctions qui permettent de crer des carte simples

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



function listing_des_dossiers()

local ancien_chemin = System.currentDirectory() -- on enregistre l'ancienne place du LuaPlayer
System.currentDirectory("ms0:/PSP/GAME150/IsometricCollisionCreator/mes_images") -- On se place dans les dossier "mes_images"

local liste = System.listDirectory()
local nombre = table.getn(liste) 

   
local name={}

for i=1, nombre do
 if liste[i].directory==true then 
  name[i]=liste[i].name
  end
end
	  
System.currentDirectory(ancien_chemin) -- On se replace dans l'ancien rpertoire du LuaPlayer
return  { --liste = liste,
          name=name,
          max_selecteur = nombre + 1,
		  selecteur = 1,
		  }

end



--Fonction qui vrifie si tous les fichiers neccessaires sont prsents.
-- nom = nom du dossier o doivent se trouver les images
-- type_carte = si c'est une carte simple ==> mettre "s"
--                       si c'est une carte complexe ==> mettre "c"
function verification_fichier(nom,type_carte)

local ancien_chemin = System.currentDirectory() -- on enregistre l'ancienne place du LP
System.currentDirectory("ms0:/PSP/GAME150/IsometricCollisionCreator/mes_images/"..nom) -- On se place dans les dossier ou se trouve les images


local liste = System.listDirectory()
local nombre = table.getn(liste) --on prend le ombre d'lments

local a=false
local b=false
local c=false
local d=false
local e=false
local f=false


-- Cas de carte simple :
if type_carte == "s" then
--test si les fichiers sont prsents :
 for i=1, nombre do
   if liste[i].directory==false then
      if liste[i].name=="background.png" then
	   a=true
	  end
	  if liste[i].name=="map_collision.png" then
	   b=true
	  end
	  if liste[i].name=="map_decor.png" then 
	   c=true
	  end
	  if liste[i].name=="map_decor_debug.png" then
	   d=true
	  end
    end
 end



  if a==false then
  --Utilise le message d'erreur du luaPlayer :
  error("\n\n\nIl manque l'image background.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")
         
  elseif b==false then
  error("\n\n\nIl manque l'image map_collision.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif c==false then
  error("\n\n\nIl manque l'image map_decor.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")
 
  elseif d==false then
  error("\n\n\nIl manque l'image map_decor_debug.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")
  end
 
 end -- Fin du cas de carte simple
 
 -- Cas de carte complexe 
if type_carte == "c" then
 --test si les fichiers sont prsents :
  for i=1, nombre do
   if liste[i].directory==false then
      if liste[i].name=="background.png" then
	   a=true
	  end
	  if liste[i].name=="map_collision_decor1.png" then
	   b=true
	  end
	  if liste[i].name=="map_decor1.png" then 
	   c=true
	  end
	  if liste[i].name=="map_decor2.png" then
	   d=true
	  end
	  if liste[i].name=="map_decor_debug.png" then
	   e=true
	  end
	  if liste[i].name=="map_collision_decor2.png" then
	   f=true
	  end
    end
  end
  
  if a==false then
  error("\n\n\nIl manque l'image background.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif b==false then
  error("\n\n\nIl manque l'image map_collision_decor1.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif c==false then
  error("\n\n\nIl manque l'image map_decor1.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif d==false then
  error("\n\n\nIl manque l'image map_decor2.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif e==false then
  error("\n\n\nIl manque l'image map_decor_debug.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")

  elseif f==false then
  error("\n\n\nIl manque l'image map_collision_decor2.png dans le dossier :\n\n\t\t"..nom.."\n\nVerifier puis recommencer\n\n")
  end
 
end
 
System.currentDirectory(ancien_chemin)
end





function creation_map_simple(background,map_collision,map_decor,map_decor_debug)

					

-- ***
c_map={} --table o l'on atribue les valeurs "0" ou "1" pour reprsenter le background  (0 = diffrent de noir; 1 = noir). Table qui est implmenter ci-dessous
--***      

-- Dfinition de la couleur noire :
local noir=Color.new(0,0,0)

--Dfinition de la couleur rouge :
local rouge=Color.new(255,0,0)

for y = 0, 272-1 do
		c_map[y+1] = ""
		for x = 0, 480-1 do
		local  c = map_collision:pixel(x,y) -- slectionne un pixel de l'image charge
			if c == noir  then -- si le pixel slctionn est  noir, on le reprsente avec "1" dans le tableau "c_map" (= collision_map)
				c_map[y+1] = c_map[y+1].."1" -- "1" reprsente un pixel de couleur noire (on ne passe pas)
            elseif c==rouge then
			    c_map[y+1] = c_map[y+1].."d" -- Ici, "d" ("d" comme derrire) reprsente un pixel rouge ==> On ne peut pas passer et on doit changer l'affichage du perso et du dcor	
			else
				c_map[y+1] = c_map[y+1].."0" -- Ici, "0" reprsente un pixel difffrent de noir et de rouge (a veut dire qu'on peut passer)
			end
		end
end



--*** d_map veut dire dcor_map 
d_map={} -- table o l'on attribue les valeurs "0" et "1" pour reprsenter le DECOR sur le background (0= absence de dcor; 1= prsence de dcor)
--***

-- On va maintenant tablir la carte du dcor :
for y = 0, 272-1 do
	d_map[y+1] = ""
		for x = 0, 480-1 do
		local c = map_decor:pixel(x,y) -- slectionne un pixel de l'image "map_decor" 	
		local	c = c:colors() -- prend la couleur RVB du pixel prcedemment slectionne
	      
		    
           --Gestion de la map_decor_debug :		
		    --if map_decor_debug then		
		    local d = map_decor_debug:pixel(x,y)
			local d = d:colors()
		    --end
			
			if c.a == 0 then -- si la valeur alpha de la couleur est == 0, c'est que c'est transparent
				d_map[y+1] = d_map[y+1].."0" -- "0" reprsente un pixel ou il n'y a pas de dcor 
			elseif map_decor_debug and d.a ~= 0  then -- pixel qui a une valeur alpha diffrente de la tranparence totale
 	            d_map[y+1] = d_map[y+1].."0" -- Ici, "0" reprsente un  pixel "neutre". (a veut dire qu'on ne rendra pas le perso transparent, peu importe la situation)	
			else
				d_map[y+1] = d_map[y+1].."1" -- "1" reprsente un pixel o il y a un dcor
			end
			
		end
end
	

-- On retourne la carte cre, le tableau "c_map" qui contient les donnes des zones infranchissables, et le tableau "d_map" qui contient les donnes du dcor
-- On peut mainteant accder  ses donnes en faisant par exemple (si l'on a cr un carte du nom de "map1"): map1.map
return {
     --img = background,
	 --decor = map_decor,
	 c_map = c_map,
	 d_map = d_map,
	 --x=0,
	 --y=0
	 }
	
end




function creation_fichier_map(nom)

-- verifie si tous les fichiers sont bien prsents :
verification_fichier(nom,"s") 

--on limine les majuscules de la string (sinon c'est en majuscule sans raison. Bug du luaplayer ?)
local nom=string.lower(nom)

local background=Image.load("mes_images/"..nom.."/background.png")
local map_collision=Image.load("mes_images/"..nom.."/map_collision.png")
local map_decor=Image.load("mes_images/"..nom.."/map_decor.png")
local map_decor_debug=Image.load("mes_images/"..nom.."/map_decor_debug.png")

System.createDirectory("fichiers_de_sortie/"..nom)
c_map=io.open("fichiers_de_sortie/"..nom.."/c_map.map", "w")
c_map:close()
d_map=io.open("fichiers_de_sortie/"..nom.."/d_map.map", "w")
d_map:close()

screen:clear(blanc)
screen:print(155,100,"Creation en cours...",rouge)
screen:print(155,110,"Merci de patienter")

 screen:print(367,195,"Par Dungeon")
 screen:print(0,210,"-------------------------------------------------------------------")
 screen:print(140,230,"Dure environ 1 minute")
screen.flip()

--creation des 2 tableaux ; "c_map" et "d_map" :
local fichier_map = creation_map_simple(background,map_collision,map_decor,map_decor_debug)

--creation des fichers ".map"  partir des tableaux :

c_map=io.open("fichiers_de_sortie/"..nom.."/c_map.map", "w")
for i=1 , 272 do
c_map:write(fichier_map.c_map[i].."\n")
end
c_map:close()


d_map=io.open("fichiers_de_sortie/"..nom.."/d_map.map", "w")
for i=1, 272 do
d_map:write(fichier_map.d_map[i].."\n")
end
d_map:close()


-- on dplace les images dans le dossier /fichiers_de_sortie/mon_dossier :
Copie_Coller("ms0:/PSP/GAME150/IsometricCollisionCreator/mes_images/"..nom.."/background.png" ,"ms0:/PSP/GAME150/IsometricCollisionCreator/fichiers_de_sortie/"..nom.."/background.png" ,350)
Copie_Coller("ms0:/PSP/GAME150/IsometricCollisionCreator/mes_images/"..nom.."/map_decor.png" ,"ms0:/PSP/GAME150/IsometricCollisionCreator/fichiers_de_sortie/"..nom.."/map_decor.png" ,350)



-- on informe l'utilisateur que le dossier est pret :
  oldpad=Controls.read()
while true do
  screen:clear(blanc)
  pad=Controls.read()
  
  screen:print(165,25,"##################")
  screen:print(165,33,"## FICHIER CREE ##")
  screen:print(165,41,"##################")

  screen:print(40,105,"Le dossier fichier_de_sortie/"..nom.." a ete cree ",rouge)
  screen:print(40,120,"Le moteur peut maintenant utiliser votre map")


  --on demande  l'utilisateur ce qu'il veut faire :
  screen:print(30,150,"- X Supprimer le dossier mes_images/"..nom)
  screen:print(30,162,"- L Passer en mode USB.  R pour quitter le mode USB")
  screen:print(30,174,"- Start pour creer nouvelle carte simple")
  screen:print(30,186,"- O pour tester la carte",rouge)
  
  screen:print(367,195,"Par Dungeon")
  screen:print(0,210,"-------------------------------------------------------------------")
  screen:print(174,230,"Faites votre choix")
  screen:print(80,245,"Select pour retourner au menu principal")
      --suppression  mes_images/..nom :
      if pad:cross() and oldpad:cross()~=pad:cross() then
   
        -- suppressions des fichiers
        System.removeFile("mes_images/"..nom.."/background.png")
        System.removeFile("mes_images/"..nom.."/map_collision.png")
        System.removeFile("mes_images/"..nom.."/map_decor.png")
        System.removeFile("mes_images/"..nom.."/map_decor_debug.png")
   
        --suppression du dossier :
		System.removeDirectory("mes_images/"..nom)
		
        screen:print(400,150,"Fait !",rouge)
        screen.flip()
        System.sleep(3000)
      end
   
   
   --gerstion de l'usb :
   if pad:l() and oldpad:l() ~= pad:l() then
	     System.usbDiskModeActivate()
   end
   if pad:r() and oldpad:r() ~=pad:r() then
          System.usbDiskModeDeactivate()
    end
	 
	 ---creer une nouvelle carte :
	 if pad:start() and oldpad:start()~=pad:start() then
	      --desactivation de l'usb :
          System.usbDiskModeDeactivate()
		  break --on quitte la fonction (retour dans "carte_simple")
	 end
	 
	 
	 if pad:select() and oldpad:select() ~=pad:select() then
	 	   --desactivation de l'usb :
           System.usbDiskModeDeactivate()
		  dofile ("prog.lua") 
	 end
	 
	 if pad:circle() and oldpad:circle()~=pad:circle() then
	       --desactivation de l'usb :
           System.usbDiskModeDeactivate()
		   test_carte_simple("fichiers_de_sortie/"..nom)
	 end
	 
oldpad=pad
screen.flip()
end

end





function carte_simple()


local statut=true
local pad=0
local oldpad=Controls.read()

   local dossiers = listing_des_dossiers() -- on procde au listing des dosssiers

--## Boucle du mini menu o l'on fait ses choix
while true do

screen:clear(blanc)
pad=Controls.read()

screen:print(135,5," Isometric Collision Creator")

screen:print(180,25,"##################")
screen:print(180,33,"## CARTE SIMPLE ##")
screen:print(180,41,"##################")

 if statut == true then
 screen:print(14,70,"Le dossier selectionne doit se trouver dans le dossier: ",rouge)
 screen:print(60,80,"/IsometricCollisionCreator/mes_images",rouge)
 screen:print(43,105,"Les images doivent etre correctements nommees ! ", rouge)
 screen:print(45,130,"Pour plus de details, regarder le dossier:",rouge)
 screen:print(45,140,"/IsometricCollisionCreator/mes_images/exemple",rouge)
 screen:print(147,165,"Croix pour continuer")
 
   if pad:cross() and oldpad:cross() ~= pad:cross() then             
   statut = false
   end
   
 else 
 
    if pad:left() and oldpad:left() ~= pad:left() then
	 dossiers.selecteur=dossiers.selecteur-1
	end
	if pad:right() and oldpad:right() ~= pad:right() then
     dossiers.selecteur=dossiers.selecteur+1
    end
		      if dossiers.selecteur<=0 then 
			   dossiers.selecteur=dossiers.max_selecteur-1
			  end
			  if dossiers.selecteur>=dossiers.max_selecteur then
			   dossiers.selecteur=1
			  end
			  
			  
 screen:print(55,100,"Nom du dossier :")
 screen:print(80,130,dossiers.name[dossiers.selecteur])
 screen:print(53,130,"<=                                          =>")
  screen:print(41,260,"Fleches pour changer de dossier, Croix pour valider")
 
      
	  if pad:cross() and oldpad:cross()~=pad:cross() and dossiers.name[dossiers.selecteur]~="." and dossiers.name[dossiers.selecteur]~=".."  then
	   creation_fichier_map(dossiers.name[dossiers.selecteur],"s")
      end
 end
 

  
 


 screen:print(367,195,"Par Dungeon")
 screen:print(0,210,"-------------------------------------------------------------------")
 screen:print(55,230,"Choisissez le dossier qui contient vos images")
 screen:print(80,245,"Select pour retourner au menu principal")

  if pad:select() and oldpad:select() ~= pad:select() then
   dofile ("prog.lua")
  end
 
 oldpad=pad
 screen.flip()
 end








end
