--[[                                                             

Copyright (C) 2008 Pascal Julien

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
						  
									  
					

                                        ###################################
                                      ##      IsometricEngine  Version PGE       cod par Dungeon    ##
                                      ###################################          		
									  
-- Date de commencement : 25/07/08
-- Dernire modification : 29/07/08
 
 Description : IsometricEngine est un moteur de collision isomtrique. Il simplifie grandement le codage d'un jeu type RPG.
 
	 	  
	  --]]
	  
	  
	  
	  -- ## Initialisation des variables ncessaires au moteur :
	 
	 
  --##  v_s_temp = variable_systeme_temporaire . Il s'agit d'une structure o je stocke des donnes temporaires qui sont ncessaire au bon fonctionnement du systme de collision :
     v_s_temp = {
     inverser_affichage=false, --variable qui sert  rendre plus prcis le systme
	 inverser_affichage_complexe1=false,
	 inverser_affichage_complexe2=false,
     debut_haut = 0,      -- variables
     debut_gauche = 0,       --           qui servent  se 
     fin_droite = 0,    --                                           dplacer sur
     fin_bas = 0,       --                                                                 la "d_map"
 }
	  
	  
 --##  v_m_temp = vaiables de mouvement temporaire. Il s'agit d'une structure o je stocke des donnes temporaires ncessaires aux dplacements  :
     v_m_temp = {
     old_x=0, -- Stocke les anciennes positions 
     old_y=0, ---                                                    x et y du perso  ==> Utile pour les collisions 
  
 }
 
 
 
 -- ## Les Fonctions :
  
  
	  -- ## Fonction qui charge en un seul coup votre carte simple. 
	  -- Exemple :  carte1 = chargement carte_simple("Data/mes_cartes/carte1")
	  function chargement_carte_simple(chemin_dossier)

	  
	  -- les donnes des doc ".map" sont mis dans un tableau :
	  
	   -- 1rement : les donnes de la d_map :
	   local file = pge.file.open(chemin_dossier.."/d_map.map", PGE_FILE_RDONLY)
	   
	   if not file then
        error("Error opening file.")
       end
	   local d_map={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map[y+1] = ""
	   ligne = pge.file.read(file,481) -- lire 480 octets
	   d_map[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  -- Puis les donnes de la c_map :
	  local file = pge.file.open(chemin_dossier.."/c_map.map", PGE_FILE_RDONLY)
	  
	  if not file then
        error("Error opening file.")
       end
	  local c_map={}
	  local ligne = 0
	  
	  for y = 0, 272-1 do
	   c_map[y+1] = ""
	   ligne = pge.file.read(file,481) -- lire 480 octets
	   c_map[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  --Chargement des images + activation
	  local img1= pge.texture.load(chemin_dossier.."/background.png")
	  local img2= pge.texture.load(chemin_dossier.."/map_decor.png")

	  
	  return  {
	  img = img1, 
	  decor = img2,
	  c_map = c_map,
	  d_map = d_map,
	  x=0,
	  y=0,
	  type_carte = "S", -- "S" pour simple
	  }
	  
	  
	  
	  end
	  
	  
	  
	  -- Fonction qui pr-charge votre carte simple, pour pouvoir finir de la charg plus rapidement par la suite.
	  -- Ne charge que les documents ".map" de votre carte
	  -- Ex : carte1 = pre_chargement_map_simple("carte1")
	  function pre_chargement_carte_simple(chemin_dossier)
	  
	   -- 1rement : les donnes de la d_map :
	   local file = pge.file.open(chemin_dossier.."/d_map.map", PGE_FILE_RDONLY)
	   
	   if not file then
        error("Error opening file.")
       end
	   local d_map={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map[y+1] = ""
	   ligne = pge.file.read(file,481)
	   d_map[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  	  -- Puis les donnes de la c_map :
	  local file = pge.file.read(chemin_dossier.."/c_map.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	  local c_map={}
	  local ligne = 0
	  
	  for y = 0, 272-1 do
	   c_map[y+1] = ""
	   ligne = pge.file.read(file,481)
	   c_map[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  return {
	  
	  img=0,
	  decor=0,
	  c_map = c_map,
	  d_map = d_map,
	  x=0,
	  y=0,
	  type_carte = "S", -- "S" pour simple
	  }
	  
	  end

	  
	  	  -- Fonction qui fini de charg votre carte simple. 
	  -- Charge les images de votre carte simple.
	  function finir_chargement_carte_simple(nom_variable,chemin_dossier)
	  
	  nom_variable.img=pge.texture.load(chemin_dossier.."/background.png")
	  nom_variable.decor=pge.texture.load(chemin_dossier.."/map_decor.png")
	  --on active les textures :
	  --nom_variable.img:activate()
	  --nom_variable.img:activate()
	  
	  
	  end
	  
	  
	  
	  	  --Fonction qui vide une carte de la ram une carte (simple ou complexe)
	  -- nom = nom de la carte  vider 
	 function vide_ram_carte(nom)
	   nom.img=nil
	   nom.decor=nil
	   nom.decor1=nil
	   nom.decor2=nil
	   nom.c_map=nil
	   nom.d_map1=nil --!N!
	   nom.d_map2=nil --!N!
	   nom.x=nil
	   nom.y=nil
	   nom.type_carte=nil
	   collectgarbage()
	 end
	 
	 
	 
	 	  --##Fonction qui charge d'un seul coup votre carte complexe
	  function chargement_carte_complexe(chemin_dossier)
	  
	  -- les donnes des doc ".map" sont mis dans un tableau :
	  
	   -- 1rement : les donnes de la d_map1 : !N!
	   local file = pge.file.open(chemin_dossier.."/d_map1.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	   local d_map1={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map1[y+1] = ""
	   ligne = pge.file.read(file,481)
	   d_map1[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  --2mement : les donnes de la d_map2:   !N!
	   local file = pge.file.open(chemin_dossier.."/d_map2.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	   local d_map2={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map2[y+1] = ""
	   ligne = pge.file.read(file,481)
	   d_map2[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  
	  -- Puis les donnes de la c_map :
	  local file = pge.file.open(chemin_dossier.."/c_map.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	  local c_map={}
	  local ligne = 0
	  
	  for y = 0, 272-1 do
	   c_map[y+1] = ""
	   ligne = pge.file.read(file,481)
	   c_map[y+1] = ligne
	  end
	  
      pge.file.close(file)
	  
	  --Chargement :
	  local img1=pge.texture.load(chemin_dossier.."/background.png")
	  if img1==nil then
	   error("Can't load img1")
	  end
	  local img2=pge.texture.load(chemin_dossier.."/map_decor1.png")
	  if img2==nil then
	    error("Can't load img2")
	  end
	  local img3=pge.texture.load(chemin_dossier.."/map_decor2.png")
      if img3==nil then
	    error("Can't load img3")
	  end
	  
	  return  
	  {
	  img = img1, 
	  decor1 = img2,
	  decor2 = img3,
	  c_map = c_map,
	  d_map1 = d_map1,
	  d_map2 = d_map2,
	  x=0,
	  y=0,
	  type_carte = "C", -- "C" pour complexe
	  }
	  
	 
	  end
	  
	  
	  --##Fonction qui pr-charge une carte complexe :
-- On ne charge pas les images.
function pre_chargement_carte_complexe(chemin_dossier)



	  -- les donnes des doc ".map" sont mis dans un tableau :
	  
	   -- 1rement : les donnes de la d_map1 : !N!
	   local file = pge.file.open(chemin_dossier.."/d_map1.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	   local d_map1={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map1[y+1] = ""
	   ligne = pge.file.read(file,481)
	   d_map1[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  --2mement : les donnes de la d_map2:   !N!
	   local file = pge.file.open(chemin_dossier.."/d_map2.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	   local d_map2={}
	   local ligne = 0
	   
	  for y = 0, 272-1 do
	   d_map2[y+1] = ""
	   ligne = pge.file.read(file,481)
	   d_map2[y+1] = ligne
	  end
	  
	  pge.file.close(file)
	  
	  
	  -- Puis les donnes de la c_map :
	  local file = pge.file.open(chemin_dossier.."/c_map.map", PGE_FILE_RDONLY)
	   if not file then
        error("Error opening file.")
       end
	  local c_map={}
	  local ligne = 0
	  
	  for y = 0, 272-1 do
	   c_map[y+1] = ""
	   ligne = pge.file.read(file,481)
	   c_map[y+1] = ligne
	  end
	  
      pge.file.close(file)


     return {
	  img = 0,    --
	  decor1 = 0,    -- On ne charge pas les images
	  decor2 = 0,     --
	  c_map = c_map,
	  d_map1 = d_map1,
	  d_map2 = d_map2,
	  x=0,
	  y=0,
	  type_carte = "C", -- "C" pour complexe
	  }

end



--##Fonction qui finie de charger votre carte complexe :
function finir_chargement_carte_complexe(nom_variable,chemin_dossier)

	 nom_variable.img=pge.texture.load(chemin_dossier.."/background.png")
	 nom_variable.decor1=pge.texture.load(chemin_dossier.."/map_decor1.png")
	 nom_variable.decor2=pge.texture.load(chemin_dossier.."/map_decor2.png")

end



-- ## fonction a utiliser  chaque fois qu'on charge un sprite !
-- ** Remarque : lorsque l'on charge un sprite, on attribue aussi  sa variable sa largeur, sa hauteur, et sa table reprsentant ses pixels. **
function load_sprite(file)
	local img = pge.texture.load(file) --charge l'image
	 --     img:activate()
	local width = pge.texture.width(img)   -- largeur de l'image
	local height = pge.texture.height(img) -- hauteur de l'image
	local c_map = {}  --table o l'on atribue les valeurs "0" ou "1" pour reprsenter le perso simplement . Table qui est implmenter ci-dessous
	                  --Remarque : utile que dans la fonction "collision()" ==> pour deux persos en mouvement.
					  
	-- on construit la table avec des valeurs "0" ou "1" (des chanes de caractres)
	for y = 0, height-1 do
		c_map[y+1] = ""
		for x = 0, width-1 do
			local c = pge.texture.pixel(img,x,y) -- slectionne un pixel de l'image charge
			local d = pge.gfx.alpha(c) -- prend la couleur RVB du pixel prcedemment slectionne
			if d == 0 then -- si la valeur alpha de la couleur est == 0, c'est que c'est transparent
				c_map[y+1] = c_map[y+1].."0" -- "0" reprsente un pixel transparent
			else
				c_map[y+1] = c_map[y+1].."1" -- "1" reprsente un pixel color
			end
		end
	end
	
	
	
	return {
		img = img,
		width = width,
		height = height,
		x = 0,
		y = 0,
		c_map = c_map
	}
end

--##Pour dcharger un sprite de la ram
function unload_sprite(nom_variable)

nom_variable.img=nil
nom_variable.width=nil
nom_variable.height=nil
nom_variable.x=nil
nom_variable.y=nil
nom_variable.c_map=nil

collectgarbage()

end


--## function qui peut etre utile pour deux perso en mouvements. Dans d' autres cas, elle est inutile.       REMARQUE  IMPORTANTE : "obj1" et "obj2" sont deux sprites qui ont t charg avec "load_sprite()" !
-- Cette fonction est de Soulkiller. Merci  lui
function collision_sprite(obj1, obj2)
	-- 1er test classique de blocs :
	if not ((obj1.x + obj1.width > obj2.x) and (obj1.x < obj2.x + obj2.width) and (obj1.y + obj1.height > obj2.y) and (obj1.y < obj2.y + obj2.height)) then
		return false --si les deux blocs ne se touche pas, il n'y a pas collision, on sort de la fonction
	end
	x_offset1 = 0
	x_offset2 = 0
	y_offset1 = 0
	y_offset2 = 0
	
	-- calculate the coords and size of the overlapping area of the images
	if obj1.x > obj2.x then 
		c_x1 = obj1.x 
		x_offset1 = 1
		x_offset2 = obj1.x-obj2.x + 1
	else 
		c_x1 = obj2.x
		x_offset1 = obj2.x-obj1.x + 1
		x_offset2 = 1
	end
	
	if obj1.y > obj2.y then 
		c_y1 = obj1.y 
		y_offset1 = 1
		y_offset2 = obj1.y-obj2.y + 1
	else
		c_y1 = obj2.y 
		y_offset1 = obj2.y-obj1.y + 1
		y_offset2 = 1
	end
	
	if (obj1.x + obj1.width) > (obj2.x + obj2.width) then 
		c_x2 = (obj2.x + obj2.width)
	else
		c_x2 = (obj1.x + obj1.width) 
	end
	if (obj1.y + obj1.height) > (obj2.y + obj2.height) then 
		c_y2 = (obj2.y + obj2.height) 
	else
		c_y2 = (obj1.y + obj1.height)
	end
	
	c_w = c_x2-c_x1
	c_h = c_y2-c_y1
	
	
	-- use the coords of the overlapping areas to cut out segments of the strings in the collision map and use for pixel-perfect collision test (Eh oui! c'est de la collision par pixel ^^)
	for i = 0, c_h-1 do
		a = tonumber(obj1.c_map[i+y_offset1]:sub(x_offset1, x_offset1+c_w))
		b = tonumber(obj2.c_map[i+y_offset2]:sub(x_offset2, x_offset2+c_w))
		test = tostring(a + b)
		if test:match"2" then
			return true
		end
	end
	return false
end 





--##  Fonction qui calcul les coordonnes pour se positionner sur les "d_map" et "c_map" de la /ou les maps que lesquels on se situe :
function calcul_position_map(obj,map)


 v_s_temp.debut_haut = obj.y
 v_s_temp.debut_gauche = obj.x
 v_s_temp.fin_bas = obj.y + obj.height
 v_s_temp.fin_droite = obj.x + obj.width

 
 -- conditions spciales, pour viter les bugs (Par exemple si on est sort de l'image en partie ):          
   if obj.y<=0 then         
     v_s_temp.debut_haut = 1 -- si on sort de l'image en haut 
    elseif v_s_temp.fin_bas>=272 then 
	 v_s_temp.fin_bas = 271 -- si on sort de l'image en bas
   end      
 

   if obj.x<0 then
     v_s_temp.debut_gauche = 1 -- Si on sort  gauche
    elseif v_s_temp.fin_droite>=480 then
     v_s_temp.fin_droite = 479 -- Si on sort  droite
   end
   
 
end



-- ## Fonction qui renvoie "true" si le perso est en contact avec le dcor, ou "false" si ce n'est pas le cas
--obj = un sprite charg avec load_sprite
--map = une carte charg avec "chargement_carte_simple()" ou "chargement_carte_complexe()"

function collision_decor(obj,map)
  
-- On va regarder tout autour du perso si il y a collision du perso (avec le dcor) ou non :

	
      local i=-1                                 
     --test si il y a collision sur toutes les lignes :
	 for j=v_s_temp.debut_haut, v_s_temp.fin_bas do
      i=i+1
		 local a=map.d_map[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)

		   if a:match("1") then
		       return true
		   end
     end

	      
	-- Si on arrive ici, c'est que la fonction n'a dtct aucune collision. On retourne donc la valeure "false" :
	return false
end


--## La mme chose que prcedemment mais pour les cartes coplexes :
function collision_decor_complexe(obj,map,numero)
	
 if numero == 1 then
 
     local i=-1                                 
     --test si il y a collision sur toutes les lignes :
	 for j=v_s_temp.debut_haut, v_s_temp.fin_bas do
      i=i+1
		 local a=map.d_map1[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)

		   if a:match("1") then
		       return true
		   end
     end

  elseif numero== 2 then
    
	 local i=-1                                 
     --test si il y a collision sur toutes les lignes :
	 for j=v_s_temp.debut_haut, v_s_temp.fin_bas do
      i=i+1
		 local a=map.d_map2[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)

		   if a:match("1") then
		       return true
		   end
     end
	 
   else 
   error("Dans la fonction collision_decor_complexe : numero ~= 1 ou 2")
   end
   
end



-- Fonction qui va regarder si il y a une collision avec les obstacles (= les zones noires)
function collision_obstacle(obj,map)


	 
	 local obstacle=false
	 local obstacle_haut=false
	 local  obstacle_bas=false
	 local obstacle_gauche=false
	 local obstacle_droite=false
     


	--[[  test qui se rvle inutile. On a pas besoin de savoir qi il ya collision sur la ligne du haut. 
	-- test si il y a collision sur la ligne du haut :
	local a=map.c_map[v_s_temp.debut_haut]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		 
		   if a:match("1") then
		       obstacle_haut=true
			   obstacle=true
		   end
		   
	]]
		   
		   
		   
   -- test si il y a collision sur la ligne de gauche :
   local i=0
   for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
     i=i+1 --on incrmente de 1
  
		   local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.debut_gauche)
		     
			 --Si on trouve un "d", on ne doit pas passer
		     if a == "d" then 
			    obstacle_gauche=true
				obstacle=true
				break
		     end
			 
		   local b=tonumber(a)
			 if b == 1 then
		        obstacle_gauche=true
				obstacle=true
				break
		     end

	end 

	
	
	-- test si il y a collision sur la ligne de droite :
	local i=0
	for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
      i=i+1
		     local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.fin_droite,v_s_temp.fin_droite)
		       
			   if a == "d" then
			     obstacle_droite=true
			     obstacle=true
			     break
		       end
			 
			 
			 local b=tonumber(a)
		      if b == 1 then
		         obstacle_droite=true
				 obstacle=true
				 break
		      end
	end
   
	
	--test si il y a collision sur les deux ligne du bas du perso:
	    -- Sur la ligne la plus en bas
		local a=map.c_map[v_s_temp.fin_bas]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		 
		   if a:match("1") then
		       obstacle_bas=true
			   obstacle=true
		   elseif a:match("d") then
		       obstacle_bas=true
			   obstacle=true
			   v_s_temp.inverser_affichage=true -- On doit inverser l'affichage
		   end
		   
		-- Sur le ligne juste plus haut :  
		local a=map.c_map[v_s_temp.fin_bas-1]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		   
		   --Remarque : Pas la peine de cherche si on trouvde des "d".
		   if a:match("1") then
		       obstacle_bas=true
			   obstacle=true
			elseif a:match("d") then
			  obstacle_bas=true
			  obstacle=true
		   end		
		  
		   
	-- On retourne les valeurs :
	return {
	        obstacle=obstacle,
			obstacle_bas=obstacle_bas,
			obstacle_haut=obstacle_haut,
			obstacle_gauche=obstacle_gauche,
			obstacle_droite=obstacle_droite
			}

end



-- La mme chose mais pour des cartes complexes :
function collision_obstacle_complexe(obj,map)

	 local obstacle1=false
	 local obstacle_haut1=false
	 local obstacle_bas1=false
	 local obstacle_gauche1=false
	 local obstacle_droite1=false
	 
	 local obstacle2=false
	local  obstacle_haut2=false
	 local obstacle_bas2=false
	 local obstacle_gauche2=false
	 local obstacle_droite2=false
	 
	 
 --TEST AVEC LES "1" :
 
	 -- test si il y a collision sur la ligne de gauche :
   local i=0
   for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
     i=i+1 --on incrmente de 1
  
		   local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.debut_gauche)
		     
			 --Si on trouve un "d", on ne doit pas passer
		     if a == "d" then 
			    obstacle_gauche1=true
				obstacle1=true
				break
		     end
			 
		   local b=tonumber(a)
			 if b == 1 then
		        obstacle_gauche1=true
				obstacle1=true
				break
		     end

	end 

	
	
	-- test si il y a collision sur la ligne de droite :
	local i=0
	for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
      i=i+1
		     local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.fin_droite,v_s_temp.fin_droite)
		       
			   if a == "d" then
			     obstacle_droite1=true
			     obstacle1=true
			     break
		       end
			 
			 
			 local b=tonumber(a)
		      if b == 1 then
		         obstacle_droite1=true
				 obstacle1=true
				 break
		      end
	end
   
	
	--test si il y a collision sur les deux ligne du bas du perso:
	    -- Sur la ligne la plus en bas
		local a=map.c_map[v_s_temp.fin_bas]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		 
		   if a:match("1") then
		       obstacle_bas1=true
			   obstacle1=true
		   elseif a:match("d") then
		       obstacle_bas1=true
			   obstacle1=true
			   v_s_temp.inverser_affichage_complexe1=true -- On doit inverser l'affichage
		   end
		   
		-- Sur le ligne juste plus haut :  
		local a=map.c_map[v_s_temp.fin_bas-1]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		   
		   --Remarque : Pas la peine de cherche si on trouvde des "d".
		   if a:match("1") then
		       obstacle_bas1=true
			   obstacle1=true
			elseif a:match("d") then
			  obstacle_bas1=true
			  obstacle1=true
		   end		
		   
		   
	-- TEST AVEC LES "2" :
	
	-- test si il y a collision sur la ligne de gauche :
   local i=0
   for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
     i=i+1 --on incrmente de 1
  
		   local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.debut_gauche,v_s_temp.debut_gauche)
		     
			 --Si on trouve un "d", on ne doit pas passer
		     if a == "a" then  --"a" pour "arrire"
			    obstacle_gauche2=true
				obstacle2=true
				break
		     end
			 
		   local b=tonumber(a)
			 if b == 2 then
		        obstacle_gauche2=true
				obstacle2=true
				break
		     end

	end 

	
	
	-- test si il y a collision sur la ligne de droite :
	local i=0
	for j=v_s_temp.debut_haut, v_s_temp.fin_bas-1 do
      i=i+1
		     local a=map.c_map[v_s_temp.debut_haut+i]:sub(v_s_temp.fin_droite,v_s_temp.fin_droite)
		       
			   if a == "a" then
			     obstacle_droite2=true
			     obstacle2=true
			     break
		       end
			 
			 
			 local b=tonumber(a)
		      if b == 2 then
		         obstacle_droite2=true
				 obstacle2=true
				 break
		      end
	end
   
	
	--test si il y a collision sur les deux ligne du bas du perso:
	    -- Sur la ligne la plus en bas
		local a=map.c_map[v_s_temp.fin_bas]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		 
		   if a:match("2") then
		       obstacle_bas2=true
			   obstacle2=true
		   elseif a:match("a") then
		       obstacle_bas2=true
			   obstacle2=true
			   v_s_temp.inverser_affichage_complexe2=true -- On doit inverser l'affichage
		   end
		   
		-- Sur le ligne juste plus haut :  
		local a=map.c_map[v_s_temp.fin_bas-1]:sub(v_s_temp.debut_gauche,v_s_temp.fin_droite)
		   
		   if a:match("2") then
		       obstacle_bas2=true
			   obstacle2=true
			elseif a:match("a") then
			  obstacle_bas2=true
			  obstacle2=true
		   end		
		   
		   
		   	-- On retourne les valeurs :
	return {
	        obstacle1=obstacle1,
			obstacle_bas1=obstacle_bas1,
			obstacle_haut1=obstacle_haut1,
			obstacle_gauche1=obstacle_gauche1,
			obstacle_droite1=obstacle_droite1,
			
		    obstacle2=obstacle2,
			obstacle_bas2=obstacle_bas2,
			obstacle_haut2=obstacle_haut2,
			obstacle_gauche2=obstacle_gauche2,
			obstacle_droite2=obstacle_droite2,		
			}

end


--Fonction qui gre les cas lorsque le perso est en collision avec les obstacles (si le perso peut avancer ou non) :
-- "test_co" est une variable qui doit contenir le rsultat de "collision_obstacle()" ou "collision_obstacle_complexe()"
-- Ex :             test = collision_obstacle(perso1,carte1)
--                     bloc_perso(perso1,test)
function bloc_perso(obj,test_co)

--Cas simples o les dimensions de "la zone noire" est plus grande que celle du perso :
  if test_co.obstacle_bas==true then
  obj.x=v_m_temp.old_x
  obj.y=v_m_temp.old_y
 
          --Pour viter le bug lorsqu'on se situe derrire le dcor et que l'on rentre en collision avec l'obstacle :
		       test_co.obstacle_bas=false   
   elseif test_co.obstacle_bas1==true then
  obj.x=v_m_temp.old_x
  obj.y=v_m_temp.old_y
                test_co.obstacle_bas1=false
				
  elseif test_co.obstacle_bas2==true then
  obj.x=v_m_temp.old_x
  obj.y=v_m_temp.old_y
                 test_co.obstacle_bas2=false
	end
	
end


-- La si belle et si attendue fonction qui gre les collisions  des cartes simples :-)  :
function collision(obj,map)

--A chaque tour de boucle on doit remettre ce boolen sue "false".
v_s_temp.inverser_affichage=false

-- calcul tout les cas o le perso ne se situe pas sur la map en question :
if obj.x+map.x<0-obj.width then  return false  end -- si il n'est pas sur la carte  (trop  gauche)
if obj.x+map.x>480 then  return false           end -- si le perso n'est pas sur la carte (trop  droite)
if obj.y+map.y<=1-obj.height then  return false  end -- si le perso n'est pas sur la carte (trop en haut)
if obj.y+map.y>272 then  return false           end --si le perso n'est pas sur la carte (trop en bas)

-- Maintenant que l'on sait qu'on se trouve sur la map, on va procder aux tests de collision :

 -- calcul des positions :
  calcul_position_map(obj,map)


--Tests de collision avec le dcor :
local resultat_decor=collision_decor(obj,map)

-- Tests de collision avec les obstacles :
-- Remarque : La variable locale "test_co" est une strucure. Exemple : test_co.obstacle_bas, ou test_co.obstacle_haut. 
local test_co=collision_obstacle(obj,map)



    --Puis voit si on peut avancer ou non :
	bloc_perso(obj,test_co)

	 
	-- Re-calcul des positions (au cas ou on a fait reculer le perso) :
    calcul_position_map(obj,map)
	 
  -- On voit si doit blitter le dcor ou le perso en 1er :
 
		  if resultat_decor==true then 
		        
                if v_s_temp.inverser_affichage == true  then
				  return true
				 end
		        if test_co.obstacle_bas==false and test_co.obstacle_droite==false and test_co.obstacle_gauche==false then		  
		          -- On renvoie la valeur "true" pour indique qu'il faut inverser l'affichage du perso avec celui du dcor 
		          return true
		         end

		   end
		  
 -- L, on renvoie la valeur "false" pour indique qu'il n'y pas besoin d'nverser l'affichage du perso avec le dcor 
 return false	
end



--## La mme chose mais pour les cartes complexes :
function collision_carte_complexe(obj,map)

--A chaque tour de boucle on doit remettre ce boolen sur "false".
v_s_temp.inverser_affichage_complexe1=false
v_s_temp.inverser_affichage_complexe2=false

-- calcul tout les cas o le perso ne se situe pas sur la map en question :
if obj.x+map.x<0-obj.width then  return false  end -- si il n'est pas sur la carte  (trop  gauche)
if obj.x+map.x>480 then  return false           end -- si le perso n'est pas sur la carte (trop  droite)
if obj.y+map.y<=1-obj.height then  return false  end -- si le perso n'est pas sur la carte (trop en haut)
if obj.y+map.y>272 then  return false           end --si le perso n'est pas sur la carte (trop en bas)

 -- calcul des positions :
  calcul_position_map(obj,map)

  -- Tests de collision avec les obstacles :
local test_co=collision_obstacle_complexe(obj,map)

    --Puis voit si on peut avancer ou non :
	bloc_perso(obj,test_co)
	 -- re-calcul des positions :
  calcul_position_map(obj,map)
  
  
  --Tests de collision avec le dcor 1 et 2:
local resultat_decor1=collision_decor_complexe(obj,map,1)
local resultat_decor2=collision_decor_complexe(obj,map,2)

		  if resultat_decor1==true then 
		  
		        resultat_decor1=0 --on place sur 0 par dfaut. Sera modifi par la suite si remplie les conditions. "0" = ne pas inverser affichage
                if v_s_temp.inverser_affichage_complexe1 == true  then
				  resultat_decor1=1
				 end
		        if test_co.obstacle_bas1==false and test_co.obstacle_droite1==false and test_co.obstacle_gauche1==false then		  
		          --  "1" pour indiquer qu'il faut inverser l'affichage du perso avec celui du dcor 
		          resultat_decor1=1
		         end

		   else
		   resultat_decor1=0
		   end
		   
		  if resultat_decor2==true then 
		  
		        resultat_decor2=0 
                if v_s_temp.inverser_affichage_complexe2 == true  then
				  resultat_decor2=1
				 end
		        if test_co.obstacle_bas2==false and test_co.obstacle_droite2==false and test_co.obstacle_gauche2==false then		  
		          resultat_decor2=1
		         end

		   else
		   resultat_decor2=0
		   end
		   
	   
		   	--[[  Explication du numro en fonction des priorits d'affichage :
		               Ordre :
		              "0" ==>  1)background  2)decor1  3)decor2  4)perso
		              "1"  ==>  1)background  2)decor1  3)perso  4)decor2
			    "2" ==>  1)background  2)perso  3)decor1  4)decor2 --]]

		         
	if resultat_decor1==0 and resultat_decor2==1 then 
	return 1 
    elseif	resultat_decor1==1 and resultat_decor2==0 then
	return 2
	elseif resultat_decor1==1 and resultat_decor2==1 then
	return 2
	end
	
--Si on arrive ici, on retourne comme valeur "0" :
return 0
end



-- Fonction qui gre l'affichage des images et des sprites chargs avec les fonctions du moteur :
-- obj = un sprite charg avec le moteur ; 
-- img = une carte charg avec le moteur ; 
-- etat = une variable qui doit contenir le rsultat de "collision()" => Par exemple "etat_perso=collision(perso,map1)" 
function affichage_img(obj,img,etat)

 if img.type_carte == "S" then
 affichage_img_simple(obj,img,etat)
 elseif img.type_carte == "C" then
 affichage_img_complexe(obj,img,etat)
 else 
 error("Erreur dans affichage_img() ! Verifier les arguments")
 end 

end

--Fonction qui gre l'affichage des images simples.    ;-) 
function affichage_img_simple(obj,img,etat)

--le background
img.img:activate()
pge.texture.draweasy(img.img,img.x,img.y)

if etat == false then
--le dcor
img.decor:activate()
pge.texture.draweasy(img.decor,img.x,img.y)
--le perso
obj.img:activate()
pge.texture.draweasy(obj.img,obj.x,obj.y)
else
obj.img:activate()
pge.texture.draweasy(obj.img,obj.x,obj.y)
img.decor:activate()
pge.texture.draweasy(img.decor,img.x,img.y)
end

end

--Fonction qui gre l'affichage des images complexes 
function affichage_img_complexe(obj,img,etat)

img.img:activate()
pge.texture.draweasy(img.img,img.x,img.y) --background

if etat == 1 then
img.decor1:activate()
pge.texture.draweasy(img.decor1,img.x,img.y) --le decor1
obj.img:activate()
pge.texture.draweasy(obj.img,obj.x,obj.y)    --le perso
img.decor2:activate()
pge.texture.draweasy(img.decor2,img.x,img.y) --le decor2
elseif etat == 2 then
obj.img:activate()
pge.texture.draweasy(obj.img,obj.x,obj.y)
img.decor1:activate()
pge.texture.draweasy(img.decor1,img.x,img.y)
img.decor2:activate()
pge.texture.draweasy(img.decor2,img.x,img.y)
else 
img.decor1:activate()
pge.texture.draweasy(img.decor1,img.x,img.y) --le decor1
img.decor2:activate()
pge.texture.draweasy(img.decor2,img.x,img.y) --le decor2$
obj.img:activate()
pge.texture.draweasy(obj.img,obj.x,obj.y)    --le perso
end

end


